# This file was created automatically by SWIG.
import propertyoutputc
class PropertyOutputInitPtr :
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C PropertyOutputInit instance at %s>" % (self.this,)
class PropertyOutputInit(PropertyOutputInitPtr):
    def __init__(self,this):
        self.this = this




class ScalarPropertyOutputInitPtr(PropertyOutputInitPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C ScalarPropertyOutputInit instance at %s>" % (self.this,)
class ScalarPropertyOutputInit(ScalarPropertyOutputInitPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(propertyoutputc.new_ScalarPropertyOutputInit,_args,_kwargs)
        self.thisown = 1




class TwoVectorPropertyOutputInitPtr(PropertyOutputInitPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C TwoVectorPropertyOutputInit instance at %s>" % (self.this,)
class TwoVectorPropertyOutputInit(TwoVectorPropertyOutputInitPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(propertyoutputc.new_TwoVectorPropertyOutputInit,_args,_kwargs)
        self.thisown = 1




class ThreeVectorPropertyOutputInitPtr(PropertyOutputInitPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C ThreeVectorPropertyOutputInit instance at %s>" % (self.this,)
class ThreeVectorPropertyOutputInit(ThreeVectorPropertyOutputInitPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(propertyoutputc.new_ThreeVectorPropertyOutputInit,_args,_kwargs)
        self.thisown = 1




class SymmMatrix3PropertyOutputInitPtr(PropertyOutputInitPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C SymmMatrix3PropertyOutputInit instance at %s>" % (self.this,)
class SymmMatrix3PropertyOutputInit(SymmMatrix3PropertyOutputInitPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(propertyoutputc.new_SymmMatrix3PropertyOutputInit,_args,_kwargs)
        self.thisown = 1




class PropertyOutputPtr :
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def name(self, *_args, **_kwargs):
        val = apply(propertyoutputc.PropertyOutput_name,(self,) + _args, _kwargs)
        return val
    def evaluate(self, *_args, **_kwargs):
        val = apply(propertyoutputc.PropertyOutput_evaluate,(self,) + _args, _kwargs)
        return val
    def getFloatParam(self, *_args, **_kwargs):
        val = apply(propertyoutputc.PropertyOutput_getFloatParam,(self,) + _args, _kwargs)
        return val
    def getIntParam(self, *_args, **_kwargs):
        val = apply(propertyoutputc.PropertyOutput_getIntParam,(self,) + _args, _kwargs)
        return val
    def getStringParam(self, *_args, **_kwargs):
        val = apply(propertyoutputc.PropertyOutput_getStringParam,(self,) + _args, _kwargs)
        return val
    def getEnumParam(self, *_args, **_kwargs):
        val = apply(propertyoutputc.PropertyOutput_getEnumParam,(self,) + _args, _kwargs)
        return val
    def getRegisteredParamName(self, *_args, **_kwargs):
        val = apply(propertyoutputc.PropertyOutput_getRegisteredParamName,(self,) + _args, _kwargs)
        return val
    def __repr__(self):
        return "<C PropertyOutput instance at %s>" % (self.this,)
class PropertyOutput(PropertyOutputPtr):
    def __init__(self,this):
        self.this = this




class PropertyOutputRegistrationPtr :
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def name(self, *_args, **_kwargs):
        val = apply(propertyoutputc.PropertyOutputRegistration_name,(self,) + _args, _kwargs)
        return val
    def initializer(self, *_args, **_kwargs):
        val = apply(propertyoutputc.PropertyOutputRegistration_initializer,(self,) + _args, _kwargs)
        if val: val = PropertyOutputInitPtr(val) 
        return val
    def instantiate(self, *_args, **_kwargs):
        val = apply(propertyoutputc.PropertyOutputRegistration_instantiate,(self,) + _args, _kwargs)
        if val: val = PropertyOutputPtr(val) ; val.thisown = 1
        return val
    def __repr__(self):
        return "<C PropertyOutputRegistration instance at %s>" % (self.this,)
class PropertyOutputRegistration(PropertyOutputRegistrationPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(propertyoutputc.new_PropertyOutputRegistration,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: propertyoutput.spy,v $
# $Revision: 1.6 $
# $Author: reida $
# $Date: 2006/07/19 20:47:00 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov.

from oof2.SWIG.engine import outputval
from oof2.SWIG.engine import symmmatrix
from oof2.common import debug
from oof2.common import utils
from oof2.common.IO import output
from oof2.engine.IO import outputClones
import types, sys

# The PropertyOutputRegistration subclasses create an Output object
# for each registered PropertyOutput.  This bridges the gap between
# the C++ PropertyOutputs and the more general Python Outputs.
    
##### Scalar outputs

class ScalarPropertyOutputRegistration(PropertyOutputRegistration):
    def __init__(self, name, initializer=None, parameters=[],
                 tip=None, discussion=None):
        PropertyOutputRegistration.__init__(
            self, name, initializer or ScalarPropertyOutputInit())
        op = output.Output(name=name,
                           callback=self.opfunc,
                           otype=types.FloatType,
                           params=parameters,
                           tip=tip, discussion=discussion)
        output.defineScalarOutput(name, op)
        output.defineAggregateOutput(name, op)

    def opfunc(self, mesh, elements, coords, **params):
        # Returns a list of Floats.
        po = self.instantiate(params)
        mesh.precompute()
        initializer = self.initializer()
        ans = utils.flatten1([po.evaluate(mesh, element, initializer, ecoords)
                              for element, ecoords in zip(elements, coords)])
        return [a.value() for a in ans] # convert from ScalarOutputVal to Float
    
##### SymmMatrix3 outputs.

class SymmMatrix3PropertyOutputRegistration(PropertyOutputRegistration):
    def __init__(self, name, initializer=None, parameters=[],
                 tip=None, discussion=None):
        PropertyOutputRegistration.__init__(
            self, name, initializer or SymmMatrix3PropertyOutputInit())
        op = output.Output(name=name,
                           callback=self.opfunc,
                           otype=outputval.OutputValPtr,
                           params=parameters,
                           tip=tip, discussion=discussion)
        output.defineAggregateOutput(name+":Value", op)

        compout = outputClones.ComponentOutput.clone(
            name=name+" Component",
            tip='Compute components of %s' % name,
            discussion=
            """
            <para>Compute the specified component of <link
            linkend='Output:%s'>%s</link> on a &mesh;.</para>
            """
            % (name, name))
        compout.connect('field', op)
        for param in parameters:
            compout.aliasParam('field:' + param.name, param.name)
        output.defineScalarOutput(name+":Component", compout)
        
        invout = outputClones.InvariantOutput.clone(
            name=name+" Invariant",
            tip='Compute invariants of %s' % name,
            discussion="""
            <para>Compute the specified invariant of <link
            linkend='Output:%s'>%s</link> on a &mesh;.</para>
            """
            % (name, name))
        invout.connect('field', op)
        for param in parameters:
            invout.aliasParam('field:' + param.name, param.name)
        output.defineScalarOutput(name+":Invariant", invout)
        output.defineAggregateOutput(name+":Invariant", invout)

    def opfunc(self, mesh, elements, coords, **params):
        # Returns a list of OutputVal instances.
        po = self.instantiate(params)
        mesh.precompute()
        initializer = self.initializer()
        return utils.flatten1([po.evaluate(mesh, element, initializer, ecoords)
                               for element, ecoords in zip(elements, coords)])


## ThreeVector outputs
# TODO: These should add themselves as "Value" outputs, and there
# should be an "Invariant" output, also, since 3-vectors have a
# magnitude.
class ThreeVectorPropertyOutputRegistration(PropertyOutputRegistration):
    def __init__(self, name, initializer=None, parameters=[],
                 tip=None, discussion=None):
        PropertyOutputRegistration.__init__(
            self, name, initializer or ThreeVectorPropertyOutputInit())
        op = output.Output(name=name,
                           callback=self.opfunc,
                           otype=outputval.OutputValPtr,
                           params=parameters,
                           tip=tip,
                           discussion=discussion)
        output.defineAggregateOutput(name, op)

        compout = outputClones.ComponentOutput.clone(
            name=name+" Component",
            tip='Compute components of %s' % name,
            discussion=
            """
            <para>Compute the specified component of <link
            linkend='Output:%s'>%s</link> on a &mesh;.</para>
            """
            % (name, name))
        compout.connect('field', op)
        for param in parameters:
            compout.aliasParam('field:'+param.name, param.name)
        output.defineScalarOutput(name+":Component", compout)
        
    def opfunc(self, mesh, elements, coords, **params):
        # Returns a list of OutputVal instances.
        po = self.instantiate(params)
        mesh.precompute()
        initializer = self.initializer()
        return utils.flatten1([po.evaluate(mesh, element, initializer, ecoords)
                               for element, ecoords in zip(elements, coords)])
